export const cursorIndex: import("svelte/store").Writable<number>;
/** @typedef {typeof __propDef.props}  CodeMirrorProps */
/** @typedef {typeof __propDef.events}  CodeMirrorEvents */
/** @typedef {typeof __propDef.slots}  CodeMirrorSlots */
export default class CodeMirror extends SvelteComponentTyped<{
    vim?: boolean | undefined;
    errorLoc?: import("./types").StartOrEnd | null | undefined;
    diagnostics?: import("@codemirror/lint").LintSource | undefined;
    readonly?: boolean | undefined;
    tab?: boolean | undefined;
    autocomplete?: boolean | undefined;
    set?: ((options: {
        code: string;
        lang: import("./types").Lang;
    }) => Promise<void>) | undefined;
    update?: ((options: {
        code?: string | undefined;
        lang?: import("./types").Lang | undefined;
    }) => Promise<void>) | undefined;
    setCursor?: ((pos: number) => void) | undefined;
    isReady?: Promise<any> | undefined;
    resize?: (() => void) | undefined;
    focus?: (() => void) | undefined;
    getEditorState?: (() => any) | undefined;
    setEditorState?: ((state: any) => void) | undefined;
    clearEditorState?: (() => Promise<void>) | undefined;
    markText?: (({ from, to, className }: {
        from: number;
        to: number;
        className?: string | undefined;
    }) => void) | undefined;
    unmarkText?: (() => void) | undefined;
}, {
    change: CustomEvent<any>;
} & {
    [evt: string]: CustomEvent<any>;
}, {}> {
    get set(): (options: {
        code: string;
        lang: import("./types").Lang;
    }) => Promise<void>;
    get update(): (options: {
        code?: string | undefined;
        lang?: import("./types").Lang | undefined;
    }) => Promise<void>;
    get setCursor(): (pos: number) => void;
    get isReady(): Promise<any>;
    get resize(): () => void;
    get focus(): () => void;
    get getEditorState(): () => any;
    get setEditorState(): (state: any) => void;
    get clearEditorState(): () => Promise<void>;
    get markText(): ({ from, to, className }: {
        from: number;
        to: number;
        className?: string | undefined;
    }) => void;
    get unmarkText(): () => void;
}
export type CodeMirrorProps = typeof __propDef.props;
export type CodeMirrorEvents = typeof __propDef.events;
export type CodeMirrorSlots = typeof __propDef.slots;
import { SvelteComponentTyped } from "svelte";
declare const __propDef: {
    props: {
        vim?: boolean | undefined;
        errorLoc?: import("./types").StartOrEnd | null | undefined;
        diagnostics?: import('@codemirror/lint').LintSource | undefined;
        readonly?: boolean | undefined;
        tab?: boolean | undefined;
        autocomplete?: boolean | undefined;
        set?: ((options: {
            code: string;
            lang: import('./types').Lang;
        }) => Promise<void>) | undefined;
        update?: ((options: {
            code?: string | undefined;
            lang?: import("./types").Lang | undefined;
        }) => Promise<void>) | undefined;
        setCursor?: ((pos: number) => void) | undefined;
        isReady?: Promise<any> | undefined;
        resize?: (() => void) | undefined;
        focus?: (() => void) | undefined;
        getEditorState?: (() => any) | undefined;
        setEditorState?: ((state: any) => void) | undefined;
        clearEditorState?: (() => Promise<void>) | undefined;
        markText?: (({ from, to, className }: {
            from: number;
            to: number;
            className?: string | undefined;
        }) => void) | undefined;
        unmarkText?: (() => void) | undefined;
    };
    events: {
        change: CustomEvent<any>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {};
};
export {};
