export default class Compiler {
    /** @param {string} svelte_url */
    constructor(svelte_url: string);
    /** @type {Worker} */
    worker: Worker;
    /** @type {Map<number, (...arg: any) => void>} */
    handlers: Map<number, (...arg: any) => void>;
    /**
     * @param {import('../types').File} file
     * @param {import('svelte/compiler').CompileOptions} options
     * @param {boolean} return_ast
     * @returns
     */
    compile(file: import('../types').File, options: import('svelte/compiler').CompileOptions, return_ast: boolean): Promise<any>;
    destroy(): void;
}
