export default class ReplProxy {
    /**
     * @param {HTMLIFrameElement} iframe
     * @param {import("./proxy").Handlers} handlers
     */
    constructor(iframe: HTMLIFrameElement, handlers: import("./proxy").Handlers);
    /** @type {HTMLIFrameElement} */
    iframe: HTMLIFrameElement;
    /** @type {import("./proxy").Handlers} */
    handlers: import("./proxy").Handlers;
    /** @type {Map<number, { resolve: (value: any) => void, reject: (value: any) => void }>} */
    pending_cmds: Map<number, {
        resolve: (value: any) => void;
        reject: (value: any) => void;
    }>;
    /** @param {MessageEvent<any>} e */
    handle_event: (e: MessageEvent<any>) => void;
    destroy(): void;
    /**
     * @param {string} action
     * @param {any} args
     */
    iframe_command(action: string, args: any): Promise<any>;
    /**
     * @param {{ action: string; cmd_id: number; message: string; stack: any; args: any; }} cmd_data
     */
    handle_command_message(cmd_data: {
        action: string;
        cmd_id: number;
        message: string;
        stack: any;
        args: any;
    }): void;
    /**
     * @param {MessageEvent<any>} event
     */
    handle_repl_message(event: MessageEvent<any>): void;
    /** @param {string} script */
    eval(script: string): Promise<any>;
    handle_links(): Promise<any>;
}
