/** @typedef {typeof __propDef.props}  ReplProps */
/** @typedef {typeof __propDef.events}  ReplEvents */
/** @typedef {typeof __propDef.slots}  ReplSlots */
export default class Repl extends SvelteComponentTyped<{
    vim?: boolean | undefined;
    autocomplete?: boolean | undefined;
    set?: ((data: {
        files: import("./types").File[];
        css?: string | undefined;
    }) => Promise<void>) | undefined;
    update?: ((data: {
        files: import("./types").File[];
        css?: string | undefined;
    }) => void) | undefined;
    relaxed?: boolean | undefined;
    injectedJS?: string | undefined;
    injectedCSS?: string | undefined;
    embedded?: boolean | undefined;
    showAst?: boolean | undefined;
    svelteUrl?: string | undefined;
    previewTheme?: "dark" | "light" | undefined;
    packagesUrl?: string | undefined;
    orientation?: "columns" | "rows" | undefined;
    fixed?: boolean | undefined;
    fixedPos?: number | undefined;
    showModified?: boolean | undefined;
    toJSON?: (() => {
        imports: string[];
        files: import("./types").File[];
    }) | undefined;
    markSaved?: (() => void) | undefined;
}, {
    add: CustomEvent<any>;
    remove: CustomEvent<any>;
    change: CustomEvent<any>;
} & {
    [evt: string]: CustomEvent<any>;
}, {}> {
    get toJSON(): () => {
        imports: string[];
        files: import("./types").File[];
    };
    get set(): (data: {
        files: import("./types").File[];
        css?: string | undefined;
    }) => Promise<void>;
    get markSaved(): () => void;
    get update(): (data: {
        files: import("./types").File[];
        css?: string | undefined;
    }) => void;
}
export type ReplProps = typeof __propDef.props;
export type ReplEvents = typeof __propDef.events;
export type ReplSlots = typeof __propDef.slots;
import { SvelteComponentTyped } from "svelte";
declare const __propDef: {
    props: {
        vim?: boolean | undefined;
        autocomplete?: boolean | undefined;
        set?: ((data: {
            files: import('./types').File[];
            css?: string | undefined;
        }) => Promise<void>) | undefined;
        update?: ((data: {
            files: import('./types').File[];
            css?: string | undefined;
        }) => void) | undefined;
        relaxed?: boolean | undefined;
        injectedJS?: string | undefined;
        injectedCSS?: string | undefined;
        embedded?: boolean | undefined;
        showAst?: boolean | undefined;
        svelteUrl?: string | undefined;
        previewTheme?: "dark" | "light" | undefined;
        packagesUrl?: string | undefined;
        orientation?: "columns" | "rows" | undefined;
        fixed?: boolean | undefined;
        fixedPos?: number | undefined;
        showModified?: boolean | undefined;
        toJSON?: (() => {
            imports: string[];
            files: import("./types").File[];
        }) | undefined;
        markSaved?: (() => void) | undefined;
    };
    events: {
        add: CustomEvent<any>;
        remove: CustomEvent<any>;
        change: CustomEvent<any>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {};
};
export {};
